<template>
  <div v-if="addFriendModalOpen" class="overlay" @click.self="close">
    <div class="modal">
      <div class="search-label">Search for friends</div>
      <div class="search-container">
        <input v-model="search" maxlength="50" type="text" class="search">
      </div>
      <div class="result" v-if="result && !result.length"> Empty </div>
      <div class="result" v-if="result && result.length">
        <div class="result__item" v-for="(usr, index) in result" :key="index">
          {{ `${usr.firstName} ${usr.lastName}` }}
          <div class="result__plus" @click="addFriend(usr)">
            <svg height="15px" viewBox="0 0 448 448" width="12px" fill="#fff" stroke="#fff" xmlns="http://www.w3.org/2000/svg"><path d="m408 184h-136c-4.417969 0-8-3.582031-8-8v-136c0-22.089844-17.910156-40-40-40s-40 17.910156-40 40v136c0 4.417969-3.582031 8-8 8h-136c-22.089844 0-40 17.910156-40 40s17.910156 40 40 40h136c4.417969 0 8 3.582031 8 8v136c0 22.089844 17.910156 40 40 40s40-17.910156 40-40v-136c0-4.417969 3.582031-8 8-8h136c22.089844 0 40-17.910156 40-40s-17.910156-40-40-40zm0 0"/></svg>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { FRIENDS, MODAL, PROFILE } from '@/store/types'
import { debounce } from 'lodash'
export default {
  name: 'AddFriendModal',
  data: () => ({
    search: '',
    result: null
  }),
  computed: {
    addFriendModalOpen () {
      console.log('hellu', this.$store.getters[FRIENDS.GETTER.GET_ADD_FRIEND_MODAL])
      return this.$store.getters[FRIENDS.GETTER.GET_ADD_FRIEND_MODAL]
    }
  },
  watch: {
    search: debounce(function (search) {
      this.$store.dispatch(FRIENDS.ACTION.FIND_FRIENDS, { name: search })
        .then(res => (this.result = res.data))
    }, 500)
  },
  methods: {
    close () {
      this.$store.commit(FRIENDS.MUTATION.SET_ADD_FRIEND_MODAL, false)
    },
    async addFriend (usr) {
      const userId = this.$store.getters[PROFILE.GETTER.GET_USER_DATA].id
      await this.$store.dispatch(FRIENDS.ACTION.ADD_FRIEND, { userId, friendId: usr.id })
      await this.$store.dispatch(FRIENDS.ACTION.LOAD_FRIENDS)
      this.close()
      setTimeout(() => {
        this.$store.commit(MODAL.MUTATION.SET_IS_MODAL_OPEN, true)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_CONTENT, `Friend added!`)
        this.$store.commit(MODAL.MUTATION.SET_MODAL_ICON, 'success')
      }, 200)
    }
  }
}
</script>
<style lang="scss" scoped>
.overlay {
  width: 100%;
  height: 100%;
  position: fixed;
  top: 0;
  left: 0;
  z-index: 100;
  background: rgba(0,0,0,0.4);
  display: flex;
  justify-content: center;
  align-items: center;
}
.modal {
  background: white;
  border-radius: 5px;
  padding: 20px 20px;
  transition: 500ms;
  height: 250px;
  // opacity: 0;

  &--active {
    opacity: 1;
  }
}

.search-label {
  display: flex;
  justify-content: flex-start;
  margin-bottom: 10px;
  color: #ff6392;
  font-weight: bold;
  font-size: 20px;
}

.search-container {
  width: 400px;

  .search {
    width: 100%;
    padding: 20px 10px;
    box-sizing: border-box;
    height: 30px;
    font-family: Montserrat;
    font-size: 16px;
  }
}

.result {
  margin-top: 20px;

  &__item {
    display: flex;
    justify-content: space-between;
    margin-bottom: 10px;
    border-bottom: 1px solid lightgrey;
    padding: 5px 15px;
    font-size: 14px;
  }

  &__plus {
    color: #fff;
    background: #ff6392;
    width: 20px;
    height: 20px;
    display: flex;
    align-items: center;
    justify-content: center;
    cursor: pointer;
    // font-size: 30px;
    border-radius: 3px;
  }
}

</style>
